获取给定索引处控制点的坐标。 支持的平台:仅窗口 签名工 务 局: RetVal = object.GetControlPoint(Index)
返回值(RetVal)类型:变体(双精度的三元素数组) 给定索引位置处控制点的 3D WCS 坐标。 言论控制点通过向样条曲线的一部分添加权重来微调样条定义。 您可以使用属性查询样条中的控制点总数。您可以使用该方法为控制点设置新的坐标位置。您可以使用该方法为控制点设置新的权重。NumberOfControlPointsSetControlPointSetWeight 例子工 务 局: Sub Example_GetControlPoint() ' This example creates a spline object in model space. ' It then finds the coordinates of the first control point ' and changes that value. ' Create the spline Dim splineObj As AcadSpline Dim startTan(0 To 2) As Double Dim endTan(0 To 2) As Double Dim fitPoints(0 To 8) As Double startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0 endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0 fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0 fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0 fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0 Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan) ZoomAll ' Display the coordinates of the first control point Dim controlPoint As Variant controlPoint = splineObj.GetControlPoint(0) MsgBox "Control point 1 is at " & controlPoint(0) & ", " & controlPoint(1) & ", " & controlPoint(2), , "GetControlPoint Example" ' Change the coordinate of the first fit point controlPoint(0) = 0: controlPoint(1) = 3: controlPoint(2) = 0 splineObj.SetControlPoint 0, controlPoint splineObj.Update MsgBox "Control point 1 is now at " & controlPoint(0) & ", " & controlPoint(1) & ", " & controlPoint(2), , "GetControlPoint Example" End Sub Visual LISP: (vl-load-com) (defun c:Example_GetControlPoint() ;; This example creates a spline object in model space. ;; It then finds the coordinates of the first control point ;; and changes that value. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Create the spline (setq startTan (vlax-3d-point 0.5 0.5 0) endTan (vlax-3d-point 0.5 0.5 0) fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8))) (vlax-safearray-fill fitPoints '(1 1 0 5 5 0 10 0 0 ) ) (setq modelSpace (vla-get-ModelSpace doc)) (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan)) (vla-ZoomAll acadObj) ;; Display the coordinates of the first control point (setq controlPoint (vlax-safearray->list (vlax-variant-value (vla-GetControlPoint splineObj 0)))) (alert (strcat "Control point 1 is at " (rtos (nth 0 controlPoint) 2) ", " (rtos (nth 1 controlPoint) 2) ", " (rtos (nth 2 controlPoint) 2))) ;; Change the coordinate of the first fit point (setq controlPoint (vlax-3d-point 0 3 0)) (vla-SetControlPoint splineObj 0 controlPoint) (vla-Update splineObj) (setq controlPoint (vlax-safearray->list (vlax-variant-value (vla-GetControlPoint splineObj 0)))) (alert (strcat "Control point 1 is now at " (rtos (nth 0 controlPoint) 2) ", " (rtos (nth 1 controlPoint) 2) ", " (rtos (nth 2 controlPoint) 2))) ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-8 19:38
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.